/***************************************************************
* Name:         setOperations.h
*
* Purpose:      Declarations for setOperations.c
*
* Course code:  21022105
* Student name: Marius Joldos
* E-mail:       Marius.Joldos@cs.utcluj.ro
****************************************************************
* Created:      2009-11-02
*
****************************************************************/
#ifndef SETOPERATIONS_H_INCLUDED
#define SETOPERATIONS_H_INCLUDED
#include <stdlib.h>
#include <limits.h>
#define TRUE 1
#define FALSE 0
#define MAX_ELEMENTS 682
#define HOLDER_TYPE long long
#define HOLDER_SIZE CHAR_BIT * sizeof(HOLDER_TYPE)
#define MAX_HOLDERS (MAX_ELEMENTS / HOLDER_SIZE + 1)



// Global variables

// Functions
extern int isMember(HOLDER_TYPE set[], int element);
extern void makeEmpty(HOLDER_TYPE set[]);
extern void join(HOLDER_TYPE setA[], HOLDER_TYPE setB[], HOLDER_TYPE res[]);
extern void intersect(HOLDER_TYPE setA[], HOLDER_TYPE setB[], HOLDER_TYPE res[]);
extern void add(int element, HOLDER_TYPE set[]);
extern void subtract(HOLDER_TYPE setA[], HOLDER_TYPE setB[], HOLDER_TYPE res[]);
extern void copy(HOLDER_TYPE dstSet[], HOLDER_TYPE srcSet[]);
extern void listElements(HOLDER_TYPE set);
extern void readSet(HOLDER_TYPE set[]);
#endif // SETOPERATIONS_H_INCLUDED
